package com.community.huiju.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.community.commom.mode.ResponseBean;
import com.community.commom.session.UserElement;
import com.community.huiju.model.TaUserLicenseOrder;
import com.community.huiju.dao.TaUserLicenseOrderMapper;
import com.community.huiju.service.ITaUserLicenseOrderService;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Service;

/**
 * <p>
 * 月租车缴费订单表 服务实现类
 * </p>
 *
 * @author jobob
 * @since 2019-05-13
 */
@Service
public class TaUserLicenseOrderServiceImpl extends ServiceImpl<TaUserLicenseOrderMapper, TaUserLicenseOrder> implements ITaUserLicenseOrderService {

    @Override
    public ResponseBean getAll(Integer id, String licensePlate, String orderNumber, String paymentName, String paymentTel, Integer pageNum, Integer pageSize, UserElement userElement) {
        ResponseBean responseBean = new ResponseBean();
        IPage<TaUserLicenseOrder> page = new Page<>();
        page.setSize(pageSize);
        page.setCurrent(pageNum);
        QueryWrapper<TaUserLicenseOrder> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq(id != null ,"id", id);
        queryWrapper.like(StringUtils.isNotBlank(licensePlate), "license_plate", licensePlate);
        queryWrapper.like(StringUtils.isNotBlank(orderNumber), "order_number", orderNumber);
        queryWrapper.like(StringUtils.isNotBlank(paymentName), "payment_name", paymentName);
        queryWrapper.like(StringUtils.isNotBlank(paymentTel), "payment_tel", paymentTel);
        queryWrapper.eq("community_id", userElement.getCommunityId());

        IPage<TaUserLicenseOrder> orderIPage = this.page(page, queryWrapper);
        responseBean.addSuccess(orderIPage);
        return responseBean;
    }
}
